<?php

/**
 * @file
 * Provides views data for the smart_date module.
 */

use Drupal\field\FieldStorageConfigInterface;

/**
 * Implements hook_field_views_data().
 */
function smart_date_field_views_data(FieldStorageConfigInterface $field_storage) {
  // Include datetime.views.inc file in order for helper function
  // datetime_type_field_views_data_helper() to be available.
  \Drupal::moduleHandler()->loadInclude('datetime', 'inc', 'datetime.views');

  // Leverage datetime field data for value and end_value, but customize for
  // timestamp storage.
  $data = datetime_type_field_views_data_helper($field_storage, [], 'value');
  $data = datetime_type_field_views_data_helper($field_storage, $data, 'end_value');

  $columns = ['value', 'end_value'];
  $id_array = ['id' => 'date'];
  $update_ids = ['argument', 'filter', 'sort'];
  foreach ($data as $table_name => $table_data) {
    foreach ($columns as $column) {
      foreach ($update_ids as $update_id) {
        $data[$table_name][$field_storage->getName() . '_' . $column][$update_id] = $id_array;
      }
    }
  }

  return $data;
}
